Bug 642208

Summary: Review Request: mingw-win-iconv - iconv implementation using Win32 API
Product: [Fedora] Fedora Reporter: Erik van Pienbroek <erik-fedora>
Component: Package ReviewAssignee: Kalev Lember <kalevlember>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: amorilia, fedora-mingw, fedora-package-review, kalevlember, lfarkas, notting
Target Milestone: ---Flags: kalevlember: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-07-10 08:50:30 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Erik van Pienbroek 2010-10-12 06:53:06 EDT
Spec URL: http://ftd4linux.nl/contrib/mingw32-win-iconv.spec
SRPM URL: http://ftd4linux.nl/contrib/mingw32-win-iconv-0.0.1-1.fc14.src.rpm
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=2529862
Description: MinGW Windows Iconv library

$ rpmlint mingw32-win-iconv.spec 
mingw32-win-iconv.spec: W: invalid-url Source0: http://win-iconv.googlecode.com/files/win-iconv-0.0.1.tar.bz2 HTTP Error 404: Not Found
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

$ rpmlint mingw32-win-iconv-0.0.1-1.fc14.src.rpm 
mingw32-win-iconv.src: W: invalid-url Source0: http://win-iconv.googlecode.com/files/win-iconv-0.0.1.tar.bz2 HTTP Error 404: Not Found
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

$ rpmlint mingw32-win-iconv-0.0.1-1.fc14.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint mingw32-win-iconv-static-0.0.1-1.fc14.noarch.rpm
mingw32-win-iconv-static.noarch: E: arch-independent-package-contains-binary-or-object /usr/i686-pc-mingw32/sys-root/mingw/lib/libiconv.a
mingw32-win-iconv-static.noarch: W: no-documentation
mingw32-win-iconv-static.noarch: W: non-standard-dir-in-usr i686-pc-mingw32

These are harmless warnings. Googlecode and rpmlint don't play nice together. The URL works fine in Firefox. The documentation is in the main package. The other rpmlint warnings can be ignored for mingw32 packages

This package will obsolete the mingw32-iconv package as this is a more native implementation of the iconv library for Win32. This is intentional
Comment 1 amorilia 2010-12-28 09:16:28 EST
Beware, this is my very first package review. Feedback on the review by a more experienced packager is welcome, particularly if I missed any crucial steps.

[+] OK
[!] Needs to be looked into
[/] Not applicable
[*] Overridden by MinGW guidelines


Rpmlint
-------

$ rpmlint mingw32-win-iconv.spec 
mingw32-win-iconv.spec: W: invalid-url Source0: http://win-iconv.googlecode.com/files/win-iconv-0.0.1.tar.bz2 HTTP Error 404: Not Found
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

$ rpmlint mingw32-win-iconv-0.0.1-1.fc14.src.rpm 
mingw32-win-iconv.src: W: invalid-url Source0: http://win-iconv.googlecode.com/files/win-iconv-0.0.1.tar.bz2 HTTP Error 404: Not Found
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

Harmless warning, URL works:

$ wget http://win-iconv.googlecode.com/files/win-iconv-0.0.1.tar.bz2
--2010-12-28 11:15:59--  http://win-iconv.googlecode.com/files/win-iconv-0.0.1.tar.bz2
Resolving win-iconv.googlecode.com... 209.85.229.82
Connecting to win-iconv.googlecode.com|209.85.229.82|:80... connected.
HTTP request sent, awaiting response... 200 OK
Length: 17338 (17K) [application/x-bzip2]
Saving to: “win-iconv-0.0.1.tar.bz2”

100%[======================================>] 17,338      --.-K/s   in 0.1s    

2010-12-28 11:16:00 (165 KB/s) - “win-iconv-0.0.1.tar.bz2” saved [17338/17338]

$ rpm -i mingw32-win-iconv-0.0.1-1.fc14.src.rpm
$ md5sum win-iconv-0.0.1.tar.bz2
22ee1bbaae404fe34dca835f1c669a1e  win-iconv-0.0.1.tar.bz2
$ md5sum ~/rpmbuild/SOURCES/win-iconv-0.0.1.tar.bz2
22ee1bbaae404fe34dca835f1c669a1e  /home/amorilia/rpmbuild/SOURCES/win-iconv-0.0.1.tar.bz2
$ diff mingw32-win-iconv.spec ~/rpmbuild/SPECS/mingw32-win-iconv.spec  -s
Files mingw32-win-iconv.spec and /home/amorilia/rpmbuild/SPECS/mingw32-win-iconv.spec are identical

$ rpmbuild -ba mingw32-win-iconv.spec
...

Build succeeds.

$ rpmlint ~/rpmbuild/RPMS/noarch/mingw32-win-iconv-0.0.1-1.fc14.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings

$ rpmlint ~/rpmbuild/RPMS/noarch/mingw32-win-iconv-debuginfo-0.0.1-1.fc14.noarch.rpm
mingw32-win-iconv-debuginfo.noarch: E: debuginfo-without-sources
1 packages and 0 specfiles checked; 1 errors, 0 warnings.

$ rpmlint ~/rpmbuild/RPMS/noarch/mingw32-win-iconv-static-0.0.1-1.fc14.noarch.rpm
mingw32-win-iconv-static.noarch: E: arch-independent-package-contains-binary-or-object /usr/i686-pc-mingw32/sys-root/mingw/lib/libiconv.a
mingw32-win-iconv-static.noarch: W: no-documentation
1 packages and 0 specfiles checked; 1 errors, 1 warnings.

Looks fine, follows MinGW guidelines.

Dependencies
------------

$ su -c 'yum install mingw32-iconv*'
$ rpm -qa | grep mingw32-iconv
mingw32-iconv-static-1.12-12.fc12.noarch
mingw32-iconv-debuginfo-1.12-12.fc12.noarch
mingw32-iconv-1.12-12.fc12.noarch
$ su -c 'rpm -Uv /home/amorilia/rpmbuild/RPMS/noarch/mingw32-win-iconv*.rpm'
Preparing packages for installation...
mingw32-win-iconv-0.0.1-1.fc14
mingw32-win-iconv-static-0.0.1-1.fc14
mingw32-win-iconv-debuginfo-0.0.1-1.fc14
$ rpm -qa | grep mingw32-iconv
mingw32-iconv-debuginfo-1.12-12.fc12.noarch

[!] mingw32-iconv-debuginfo-1.12-12.fc12.noarch should have been removed.

$ rpmquery --requires mingw32-win-iconv
rpmlib(VersionedDependencies) <= 3.0.3-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
mingw32-filesystem >= 63
mingw32-runtime  
mingw32(kernel32.dll)  
mingw32(msvcrt.dll)  
rpmlib(PayloadIsXz) <= 5.2-1

$ rpmquery --provides mingw32-win-iconv
mingw32-iconv = 1.12-13.fc14
mingw32(libiconv.dll)  
mingw32-win-iconv = 0.0.1-1.fc14

$ rpmquery --requires mingw32-win-iconv-static
mingw32-win-iconv = 0.0.1-1.fc14
rpmlib(VersionedDependencies) <= 3.0.3-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
mingw32-filesystem >= 63
mingw32-runtime  
rpmlib(PayloadIsXz) <= 5.2-1

$ rpmquery --provides mingw32-win-iconv-static
mingw32-iconv-static = 1.12-13.fc14
mingw32-win-iconv-static = 0.0.1-1.fc14

$ rpmquery --requires mingw32-win-iconv-debuginfo
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
mingw32-filesystem >= 63
mingw32-runtime  
rpmlib(PayloadIsXz) <= 5.2-1

Does not require mingw32-win-iconv, but apparently native debuginfos are similar, so I guess this is fine.

$ rpmquery --provides mingw32-win-iconv-debuginfo
mingw32-win-iconv-debuginfo = 0.0.1-1.fc14

[!] Must also provide mingw32-iconv-debuginfo = 1.12-13.fc14

$ mock -r fedora-14-x86_64 ~/rpmbuild/SRPMS/mingw32-win-iconv-0.0.1-1.fc14.src.rpm
$ mock -r fedora-14-i386 ~/rpmbuild/SRPMS/mingw32-win-iconv-0.0.1-1.fc14.src.rpm

Both work.

Testing
-------

$ wget http://win-iconv.googlecode.com/svn-history/r10/trunk/win_iconv_test.c

and apply this patch: http://code.google.com/p/win-iconv/issues/detail?id=2

$ i686-pc-mingw32-gcc win_iconv_test.c -liconv
$ ./a.exe

All tests pass

$ i686-pc-mingw32-gcc win_iconv_test.c -Wl,-Bstatic -liconv
$ ./a.exe

All tests pass


=================================
Fedora MinGW Packaging Guidelines
=================================

[/] Track Fedora native package versions: stay at same version, include all the same patches as the native Fedora package, and be built with the same configuration options. 
[+] Packages named by prefixing upstream package name with mingw32-
[+] Use of standard mingw RPM macros %{_mingw32_xxx}
[/] Dll dependencies expressed as mingw32(*.dll)
[+] Dependencies: %global _use_internal_dependency_generator 0 %global __find_requires %{_mingw32_findrequires} %global __find_provides %{_mingw32_findprovides}
[+] BuildRequires: mingw32-filesystem >= xx
[+] BuildArch: noarch
[+] All files are installed in %{_mingw32_sysroot}
[+] .dll in %{_mingw32_bindir}, .dll.a (and .la and .a where applicable) in %{_mingw32_libdir}
[/] No man and info files which are already in Fedora native package
[+] Static libraries in -static subpackage
[+] Stripping: %global __strip %{_mingw32_strip} %global __objdump %{_mingw32_objdump}

Not in guidelines, but seems to be policy:

[+] Debuginfo: %define __debug_install_post %{_mingw32_debug_install_post} %{_mingw32_debug_package}  
[!] Package does not contain .exe files.

Contains %{_mingw32_bindir}/win_iconv.exe; is this required for the
MinGW compile stack?

===========================
Fedora Packaging Guidelines
===========================

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines .
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines .
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

readme.txt contains license

[+] MUST: The spec file must be written in American English. 
[+] MUST: The spec file for the package MUST be legible. 
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. 
[+] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. 
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[*] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[+] MUST: Packages must NOT bundle copies of system libraries.
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. 
[+] MUST: Each package must consistently use macros. 
[+] MUST: The package must contain code, or permissable content. 
[/] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. 
[*] MUST: Header files must be in a -devel package. 
[+] MUST: Static libraries must be in a -static package. 
[*] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. 
[/] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} 
[*] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
[/] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8. 
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. 
[+] SHOULD: The reviewer should test that the package builds in mock. 
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures. 

Build tested on i386 and x86_64.

[+] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. 
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. 
[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. 
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. 
[/] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.



Summary of issues
-----------------

* I could be missing something, but win_iconv.exe should probably be removed from the package as it is not required to compile against iconv.

* Somehow, mingw32-win-iconv-debuginfo should provide mingw32-iconv-debuginfo, so mingw32-iconv-debuginfo gets deleted when installing mingw32-win-iconv-debuginfo.

* Not really an issue, but a new version is available upstream (0.0.2), which also includes the static compile patch.

* A final obvious comment: the original mingw32-iconv package exposes more (but non-standard) functions, so switching to mingw32-win-iconv breaks applications that rely on these non-standard extensions. As indicated by Erik, this is intentional, and no serious problems are expected?
Comment 2 Erik van Pienbroek 2011-02-17 07:39:02 EST
Thanks for the initial review. You're doing the review very well for a first-timer!

Spec URL: http://ftd4linux.nl/contrib/mingw32-win-iconv.spec
SRPM URL: http://ftd4linux.nl/contrib/mingw32-win-iconv-0.0.2-1.fc15.src.rpm
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=2846284

* Thu Feb 17 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.0.2-1
- Update to version 0.0.2
- Dropped upstreamed patch
- Dropped the win_iconv.exe binary
- Bumped the mingw32-iconv obsoletes

The debuginfo stuff is wrapped inside the %{?_mingw32_debug_package} macro. There's no way to inject custom tags in this macro, so adding an obsoletes: mingw32-iconv-debuginfo there isn't possible at the moment. AFAIK, native Fedora packages also don't have an obsoletes on old debuginfo packages when a new package is introduced which obsoletes an old package

Once this package gets added to Fedora all packages which depend on libiconv have to be rebuild. I tested this in my mingw-w64 testing repository (which contains all current fedora mingw32 packages) and it causes no (compilation) breakage. I've also done a runtime test using my GTK-based project and it doesn't cause any side effects. This library is also used by the GLib/Gtk developers for their Win32/Win64 binaries of the Gtk stack: http://ftp.gnome.org/pub/gnome/binaries/win64/dependencies/

The packages which need to be rebuilt are (according to repoquery on a F15 host):
mingw32-fontconfig-0:2.6.0-11.fc15.noarch
mingw32-gettext-0:0.17-14.fc15.noarch
mingw32-hunspell-0:1.2.12-2.fc15.noarch
mingw32-libidn-0:1.14-7.fc15.noarch
mingw32-libxml2-0:2.7.6-2.fc15.noarch
A simple rebuild is sufficient for these packages
Comment 3 amorilia 2011-02-21 13:25:02 EST
Thanks - I've learnt a lot!

Agreed with all changes.

If I had special packager powers, I would approve your package, but
until that time, it will be up to a real packager.

For the sake of sanity checking, rpmlint output for the update package
below. Everything looks ok, as expected.

Rpmlint
-------

$ rpmlint mingw32-win-iconv.spec 
mingw32-win-iconv.spec: W: invalid-url Source0: http://win-iconv.googlecode.com/files/win-iconv-0.0.2.tar.bz2 HTTP Error 404: Not Found
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

As before, spurious warning.

$ rpmlint mingw32-win-iconv-0.0.2-1.fc15.src.rpm
mingw32-win-iconv.src: W: invalid-url Source0: http://win-iconv.googlecode.com/files/win-iconv-0.0.2.tar.bz2 HTTP Error 404: Not Found
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

As before, spurious warning.

$  rpm -i mingw32-win-iconv-0.0.2-1.fc15.src.rpm

$ md5sum ~/rpmbuild/SOURCES/win-iconv-0.0.2.tar.bz2
4300d7f337a3c13ab255d4d855057c16
$ curl -s http://win-iconv.googlecode.com/files/win-iconv-0.0.2.tar.bz2 | md5sum
4300d7f337a3c13ab255d4d855057c16

$ diff mingw32-win-iconv.spec ~/rpmbuild/SPECS/mingw32-win-iconv.spec -s
Files mingw32-win-iconv.spec and /home/amorilia/rpmbuild/SPECS/mingw32-win-iconv.spec are identical

$ rpmbuild -ba mingw32-win-iconv.spec
...

Build succeeds.

$ rpmlint ~/rpmbuild/RPMS/noarch/mingw32-win-iconv-0.0.2-1.fc14.noarch.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint ~/rpmbuild/RPMS/noarch/mingw32-win-iconv-debuginfo-0.0.2-1.fc14.noarch.rpm 
mingw32-win-iconv-debuginfo.noarch: E: debuginfo-without-sources
1 packages and 0 specfiles checked; 1 errors, 0 warnings.

$ rpmlint ~/rpmbuild/RPMS/noarch/mingw32-win-iconv-static-0.0.2-1.fc14.noarch.rpm 
mingw32-win-iconv-static.noarch: E: arch-independent-package-contains-binary-or-object /usr/i686-pc-mingw32/sys-root/mingw/lib/libiconv.a
mingw32-win-iconv-static.noarch: W: no-documentation
1 packages and 0 specfiles checked; 1 errors, 1 warnings.

Looks fine, follows MinGW guidelines.
Comment 4 Kalev Lember 2011-05-07 12:20:08 EDT
Very nice and thorough review, Amorilia!

F15 is almost out of the door and it might be a good time to give it a try in rawhide. I sent a mail about win_iconv to the Fedora MinGW mailing list, asking for comments:
http://lists.fedoraproject.org/pipermail/mingw/2011-May/003606.html
Comment 5 Kalev Lember 2011-05-11 02:52:29 EDT
No feedback to the mail, so I guess lets give it a try.

I'm approving the package based on Amorilia's review. Thanks Amorilia!

Erik, if you want to simplify some things in the spec file, then the BuildRoot tag, the 'rm -rf $RPM_BUILD_ROOT' at the beginning of %install, the whole %clean section, and the default %defattrs are no longer needed with current Fedora releases.

Also, the Obsoletes and Provides currently have %dist macro in them; it's more common to leave that out, since the 'mingw32-iconv < 1.12-14' comparison would already match the current 'mingw32-iconv-1.12-13.fc15' package:
Obsoletes:     mingw32-iconv < 1.12-14
Provides:      mingw32-iconv = 1.12-14

But these are all things one would do during the normal maintenance of a package and not blocking the review.

APPROVED
Comment 6 Erik van Pienbroek 2011-05-13 13:04:36 EDT
Thanks for approving it Kalev.
I think it would be wise to wait for some more days before requesting a git repo. The reason behind this is the legal issues surrounding mingw-w64 support. Once those are cleared (which should be any day now) we can decide to use the new mingw packaging guidelines and thus the new naming for mingw packages (mingw-* instead of mingw32-*). This package will only be introduced in rawhide anyway, so nothing is lost is we wait for some more time
Comment 7 Erik van Pienbroek 2011-06-02 10:47:47 EDT
Recently the FPC has approved a change in the packaging guidelines which allows mingw32 packages to use the prefix 'mingw-' to aid in the transition to the mingw-w64 based toolchain. Due to this approval I've updated the spec of this package.

Kalev: could you please take a quick look at the updated spec file to see if it's compliant with the new guidelines? After that I'll request a git repo named mingw-win-iconv

Spec URL: http://ftd4linux.nl/contrib/mingw32-win-iconv.spec
SRPM URL: http://ftd4linux.nl/contrib/mingw32-win-iconv-0.0.2-3.fc15.src.rpm
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=3106108

* Thu Jun  2 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.0.2-2
- Use the name mingw-win-iconv for the srpm to ease the transition to
  the mingw-w64 based toolchain
- Use the RPM 4.9 dependency generator
- Dropped unnecessary tags
Comment 8 Erik van Pienbroek 2011-06-02 10:49:30 EDT
Small typo, the spec url can be found at http://ftd4linux.nl/contrib/mingw-win-iconv.spec
Comment 9 Kalev Lember 2011-06-02 15:53:22 EDT
One blocker:
 - Obsoletes and Provides should defined for the binary package, not the srpm

Small nitpicking:
 - The automatic dep extraction that the package relies on is available in
   mingw32-filesystem >= 68, so it would be best to bump the requirement up
   from mingw32-filesystem >= 53 that the package currently has.
 - %defattr(-,root,root,-) is now the default can also be removed
Comment 10 Erik van Pienbroek 2011-06-02 16:17:59 EDT
Good spotting there! Thanks for taking another look at the package

Spec URL: http://ftd4linux.nl/contrib/mingw-win-iconv.spec
SRPM URL: http://ftd4linux.nl/contrib/mingw32-win-iconv-0.0.2-3.fc15.src.rpm

* Thu Jun  2 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.0.2-3
- Moved the obsoletes/provides to the proper location
- Bumped the requirement for mingw32-filesystem to >= 68 because of RPM 4.9 support
- Dropped the %%defattr tags
- Dropped the %%{?dist} tag from the obsoletes/provides
Comment 11 Erik van Pienbroek 2011-06-02 16:18:51 EDT
The SRPM URL should have been http://ftd4linux.nl/contrib/mingw-win-iconv-0.0.2-3.fc15.src.rpm
Comment 12 Levente Farkas 2011-06-02 16:45:55 EDT
there is already a version 0.0.3.
anyway do you really thing the a replacement package with version 0.0.3 can replace a package which version is 1.12-14?
does anyone has any test or compatibility test etc?
Comment 13 Erik van Pienbroek 2011-06-03 09:01:16 EDT
The big difference between GNU libiconv and win-iconv is that GNU libiconv has implemented all the character set conversion in its own code while win-iconv uses the Win32 API to achieve the exact same goal. Win-iconv is meant to be a drop-in replacement for GNU libiconv as it has the same API interface and all it's functions should behave the same as GNU libiconv. Projects like Glib/GTK have also been using win-iconv for some time now in their Win32 releases so this gives me the confidence that it's good to replace GNU libiconv with win-iconv (as it's much smaller than GNU libiconv). I've also been testing win-iconv in the mingw-w64 testing repo (where all packages have been rebuilt) and haven't stumbled across any regressions yet.

This proposed change was also announced to the fedora-mingw mailing list recently (see comment 4) and nobody objected to it, so we decided to continue with the review process.

It looks like the 0.0.3 version was released less than 48 hours ago. I've updated the package to use this new version:

Spec URL: http://ftd4linux.nl/contrib/mingw-win-iconv.spec
SRPM URL: http://ftd4linux.nl/contrib/mingw-win-iconv-0.0.3-1.fc15.src.rpm

* Fri Jun  3 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.0.3-1
- Update to 0.0.3
Comment 14 Levente Farkas 2011-06-22 15:37:34 EDT
please add the cmake version br too.
Comment 15 Erik van Pienbroek 2011-07-03 06:11:49 EDT
Spec URL: http://ftd4linux.nl/contrib/mingw-win-iconv.spec
SRPM URL: http://ftd4linux.nl/contrib/mingw-win-iconv-0.0.3-2.fc15.src.rpm

* Sun Jul  3 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 0.0.3-2
- Add versioned BR for cmake >= 2.8.0
Comment 16 Kalev Lember 2011-07-03 06:19:35 EDT
Looks good.
Comment 17 Erik van Pienbroek 2011-07-03 06:22:36 EDT
New Package SCM Request
=======================
Package Name: mingw-win-iconv
Short Description: Iconv implementation using Win32 API
Owners: epienbro rjones kalev
Branches: 
InitialCC:
Comment 18 Jon Ciesla 2011-07-03 08:54:51 EDT
Git done (by process-git-requests).
Comment 19 Erik van Pienbroek 2011-07-10 08:50:30 EDT
Package imported and build in rawhide successfully